#include <set>
#include <iostream>

using namespace std;

int main()
{
	set<int> s;
	s.insert(5);	
	s.insert(15);
	s.insert(2);	
	s.insert(8);
	s.insert(27);	
	s.insert(6);
	s.insert(5);

	set<int>::iterator I;
	for(I=s.begin();I!=s.end();I++)
		cout << "element  " << *I << endl;
	return 0;
}

/*!F
  certaines ancienne versions de visual C++ pourront vous mettre un warning (4786), n'en tenez pas compte.

  Tres simple : set garde en mmoire une liste trie d'lments.
  Contrairement a priority_queue qui n'est capable de vous donner QUE le premier lment, et vous oblig a dpiler pour consulter
  la liste, set garde en mmoire les lments tris.
  Ds que vous en insrez un grace a la mthode insert, il se met tout de suite a la bonne place.

  Ainsi, vous pouvez parcourir le set grace a un itrateur comme vu dans l'exemple.

  Note : set garde des lments uniques :

  si vous insrez "5" dedans, et que vous rinsrez un autre "5" ensuite (donc l'identique), le "5" n'apparaitra pas deux fois, mais qu'une seule.
  (c'est ce qu'il se passe : j'insere le 5 deux fois, et il n'apparait qu'une fois)

  pour mettre plusieurs fois le meme lments dans un "set", il faut utiliser "multiset" :

  remplacez simplement "set" par "multiset" (et pareil dans la dfinition de l'itrateur)
  et vous verrez que le 5 apparait plusieurs fois.

  (* pour info : set utilise des classes d'arbre binaire de recherche pour une optimisation des donnes et de la vitesse)


TRI PERSONNALISE
****************

  vous pouvez bien sur faire :

  set<truc, greater<truc> >

  ou 

  set<truc, monfoncteur>

  * pensez a modifier galement la dclaration de l'itrateur dans ces cas la...
  * Le tuto prcdent sur les foncteurs explique cette partie.

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Ensembles tris.
titreE: Sorted set.
meta: C++;STL
metaE: C++;STL
desc : Ensembles tris.
descE: Sorted set.
cle  : set
*/

